/**
* @description: 常量
*/

//应用编码
export const APPCODE = '96H10119';

//单据类型
export const BILL_TYPE_CODE = 'DJSK';

/**
* @description: 多语
* @param moduleId: 多语资源名
* @param domainName: 工程名
*/
export const MULTILANG = {
        moduleId: '96H10119',
        domainName: 'zjcmp_cd'
};

/**
 * 列表
 */
export const LIST = {
        page_title: '96H10119-000011',                  //页面标题 /* 国际化处理： 投融资费用*/

        page_code: '96H10119_LIST',                     //页面编码

        search_id: 'list_query',                        //查询区 
        table_id: 'list_head',                          //表格区 

        head_btn_code: 'list_head',                     //表头按钮区 
        body_btn_code: 'list_inner',                                    //表体表格按钮区
};

/**
 * 卡片
 */
export const CARD = {
        page_title: '96H10119-000011',                   //页面标题 /* 国际化处理： 投融资费用*/

        page_code: '96H10119_CARD',                      //页面编码

        form_id: 'card_head',                            //表头表单区
        table_code: 'card_body',                         //表体表格区
        table_edit_code: 'card_body_edit',               //表体表格编辑态侧拉区
        table_browse_code: 'card_body_browse',           //表体表格浏览态下拉区
        headcode: 'card_head',
        head_btn_code: 'card_head',                      //表头按钮区
        shoulder_btn_code: 'tabs_head',                  //表体肩部按钮区
        body_btn_code: 'tabs_body'                       //表体表格按钮区
};

//领域名.模块名.节点名.自定义名
//缓存标示
export const DATASOURCE = 'tm.fmc.cost.datasource';

//查询区域缓存 
export const SEARCH_CACHE = {
        key: 'tm.fmc.cost.SEARCH_CACHE',                 //查询区域缓存Key
        dataSource: DATASOURCE                                           //查询区域缓存数据的名称空间
}

//卡片缓存 
export const CARD_CACHE = {
        key: 'tm.fmc.cost.CARD_CACHE',                   //卡片区域缓存Key
        dataSource: DATASOURCE                                           //卡片区域缓存数据的名称空间
}




 
  


//请求基础路径
export const base_path = '/nccloud/zjcmp_cd/cd/';

//url
export const REQUEST_URL = {
        save: `/nccloud/zjcmp_cd/cd/savetamx_registerVO.do`,                       //保存
        delete: `/nccloud/zjcmp_cd/cd/deletetamx_registerVO.do`,                        //删除
        queryCard: `/nccloud/zjcmp_cd/cd/querycardtamx_registerVO.do`,                      //卡片查询
        queryList: `/nccloud/zjcmp_cd/cd/querypagetamx_registerVO.do`,              //列表查询
        queryListByPks: `/nccloud/zjcmp_cd/cd/querypagebypktamx_registerVO.do`,     //列表分页查询
        commit: `/nccloud/zjcmp_cd/cd/committamx_registerVO.do`,                   //提交
        unCommit: `/nccloud/zjcmp_cd/cd/uncommittamx_registerVO.do`,               //收回
        logout: `/nccloud/zjcmp_cd/cd/logouttamx_registerVO.do`,               //注销
        toCard: '/card',
        toList: '/list'
};

export const LIST_BUTTON = {
        create: 'AddBtn',
        delete: 'DelBtn',
        commit: 'CommitBtn',
        unCommit: 'UnCommitBtn',
        linkGroup: 'JointBtn',
        attachment: 'AttachmentBtn',
        approvalLink: 'DetailBtn',
        billTrack: 'TrackBtn',
        print: 'PrintBtn',
        output: 'OutputBtn',
        refresh: 'RefreshBtn',

        bodyUpdate: 'edit',
        bodyDelete: 'delete',
        bodyCommit: 'commit',
        bodyUnCommit: 'unCommit',
        copy: 'copy'
};

//列表默认禁用按钮
export const LIST_DISABLED_BUTTON = [LIST_BUTTON.delete, LIST_BUTTON.commit, LIST_BUTTON.unCommit, LIST_BUTTON.linkGroup, LIST_BUTTON.approvalLink, LIST_BUTTON.billTrack,
LIST_BUTTON.attachment, LIST_BUTTON.print, LIST_BUTTON.output];

export const CARD_BUTTON = {
        save: 'SaveBtn',
        saveAdd: 'SaveAddBtn',
        saveCommit: 'SaveCommitBtn',
        cancel: 'CancelBtn',
        create: 'CreateBtn',
        update: 'UpdateBtn',
        delete: 'DeleteBtn',
        copy: 'CopyBtn',
        commit: 'CommitBtn',
        unCommit: 'UnCommitBtn',
        attachment: 'AttachmentBtn',
        approvalLink: 'DetailBtn',
        billTrack: 'TrackBtn',
        print: 'PrintBtn',
        output: 'OutputBtn',
        refresh: 'RefreshBtn',
        back: 'Back',
        Modify: 'Modify',
        queryVersion:"queryVersion",
        addRow: 'addRow',
        deleteRow: 'deleteRow',
        copyRows: 'copyRows',
        pasteTail: 'pasteTail',
        pasteCancel: 'pasteCancel',
        logout : 'logout',
        expand: 'expand',
        insertRow: 'insertRow',
        delRow: 'delRow',
        copyRow: 'copyRow',
        fold: 'fold',
        unfold: 'unfold',
        pasteHere: 'pasteHere'
};

//卡片默认禁用按钮
export const CARD_DISABLED_BUTTON = [CARD_BUTTON.deleteRow, CARD_BUTTON.copyRows];
//卡片新增禁用按钮
export const CARD_ADD_DISABLED_BUTTON = [CARD_BUTTON.addRow, CARD_BUTTON.save, CARD_BUTTON.saveAdd, CARD_BUTTON.saveCommit];

//字段名
export const FIELD = {
        org: 'pk_org',                                                   //组织
        //orgV: 'pk_org_v',                                              //组织多版本
        billStatus: 'approvestatus',                             //单据状态字段（用以按钮控制）
        ts: 'ts'                                                                 //时间戳
};

//主属性字段名
export const PRIMARY_KEY = {
        head_id: 'pk_register',           //表头主键字段名
        body_id: 'pk_register_b',           //表体主键字段名
        bill_no: 'billno',                                               //单据编号字段名
        id: 'id' ,                                                                //单据前端缓存标识
        vdef3:'vdef3',                   //最新版本
        vdef4:'vdef4',                  //是否注销
        vdef2:'vdef2',                  //历史版本
        vdef10:'vdef10'                //变更状态

};

//状态
export const STATUS = {
        status: 'status',                                                //状态

        edit: 'edit',                                            //编辑态
        browse: 'browse',                                        //浏览态
        add: 'add',                                                              //新增态

        info: 'info',                                                    //帮助
        warning: 'warning',                                              //警告
        success: 'success',                                              //成功
        danger: 'danger',                                                //出错

        NOSTATE: '-1',                                                   //自由 态
        NOPASS: '0',                                                     //未通过 态
        PASSING: '1',                                                    //通过 态
        GOINGON: '2',                                                    //进行中 态
        COMMIT: '3'                                                              //提交 态
};



 
