package nccloud.web.gpmc.gpm.contract.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import nc.itf.gpmc.gpm.IGpmcguacontractQueryService;
import nc.vo.bd.bankdoc.BankdocVO;
import nc.vo.gpmc.gpm.contract.AggContractVersionVO;
import nc.vo.gpmc.gpm.contract.AggGuaContractVO;
import nc.vo.gpmc.gpm.contract.ContractVersionVO;
import nc.vo.gpmc.gpm.contract.CtryContractVersionVO;
import nc.vo.gpmc.gpm.contract.GuaContractVO;
import nc.vo.gpmc.gpm.contract.GuaCtryContractInfoVO;
import nc.vo.gpmc.gpm.contract.GuaGuarantyInfoVO;
import nc.vo.gpmc.gpm.contract.GuaPledgeInfoVO;
import nc.vo.gpmc.gpm.contract.GuaWarrantyInfoVO;
import nc.vo.gpmc.gpm.contract.GuarantyVersionVO;
import nc.vo.gpmc.gpm.contract.PledgeVersionVO;
import nc.vo.gpmc.gpm.contract.WarrantyVersionVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.ui.pattern.extbillcard.ExtBillCard;
import nccloud.vo.tmpub.precison.PrecisionField;
import nccloud.web.common.gpmc.action.CommonBillQueryCardAction;
import nccloud.web.tmpub.pub.translate.ExtraTranslator;
import nccloud.web.tmpub.tmc.util.CardOperatorParam;
import org.springframework.beans.BeanUtils;

public class GuaContractQueryVersionCardAction extends CommonBillQueryCardAction<AggGuaContractVO> {
	protected AggGuaContractVO[] queryBillsByPk(String pk) {
		IGpmcguacontractQueryService service = (IGpmcguacontractQueryService) ServiceLocator
				.find(IGpmcguacontractQueryService.class);
		AggGuaContractVO[] resultVOs = null;
		if (pk != null && !"".equals(pk)) {
			try {
				AggContractVersionVO[] versionVOs = service.queryVersionsByPk(pk);
				if (versionVOs != null && versionVOs.length > 0) {
					AggContractVersionVO versionVO = versionVOs[0];
					AggGuaContractVO resultVO = new AggGuaContractVO();
					ContractVersionVO version = versionVO.getParentVO();
					if (version != null) {
						GuaContractVO contract = new GuaContractVO();
						BeanUtils.copyProperties(version, contract);
						resultVO.setParentVO(contract);
						ISuperVO[] warrVersionVOs = versionVO.getChildren(WarrantyVersionVO.class);
						if (warrVersionVOs != null && warrVersionVOs.length > 0) {
							GuaWarrantyInfoVO[] warrChildren = new GuaWarrantyInfoVO[warrVersionVOs.length];

							for (int i = 0; i < warrVersionVOs.length; ++i) {
								WarrantyVersionVO childVersionVO = (WarrantyVersionVO) warrVersionVOs[i];
								GuaWarrantyInfoVO childVO = new GuaWarrantyInfoVO();
								BeanUtils.copyProperties(childVersionVO, childVO);
								warrChildren[i] = childVO;
							}

							resultVO.setChildren(GuaWarrantyInfoVO.class, warrChildren);
						}

						ISuperVO[] guarVersionVOs = versionVO.getChildren(GuarantyVersionVO.class);
						if (guarVersionVOs != null && guarVersionVOs.length > 0) {
							GuaGuarantyInfoVO[] guarChildren = new GuaGuarantyInfoVO[guarVersionVOs.length];

							for (int i = 0; i < guarVersionVOs.length; ++i) {
								GuarantyVersionVO childVersionVO = (GuarantyVersionVO) guarVersionVOs[i];
								GuaGuarantyInfoVO childVO = new GuaGuarantyInfoVO();
								BeanUtils.copyProperties(childVersionVO, childVO);
								guarChildren[i] = childVO;
							}

							resultVO.setChildren(GuaGuarantyInfoVO.class, guarChildren);
						}

						ISuperVO[] pledgVersionVOs = versionVO.getChildren(PledgeVersionVO.class);
						if (pledgVersionVOs != null && pledgVersionVOs.length > 0) {
							GuaPledgeInfoVO[] pledgChildren = new GuaPledgeInfoVO[pledgVersionVOs.length];

							for (int i = 0; i < pledgVersionVOs.length; ++i) {
								PledgeVersionVO childVersionVO = (PledgeVersionVO) pledgVersionVOs[i];
								GuaPledgeInfoVO childVO = new GuaPledgeInfoVO();
								BeanUtils.copyProperties(childVersionVO, childVO);
								pledgChildren[i] = childVO;
							}

							resultVO.setChildren(GuaPledgeInfoVO.class, pledgChildren);
						}

						ISuperVO[] ctrconVersionVOs = versionVO.getChildren(CtryContractVersionVO.class);
						if (ctrconVersionVOs != null && ctrconVersionVOs.length > 0) {
							GuaCtryContractInfoVO[] ctrconChildren = new GuaCtryContractInfoVO[ctrconVersionVOs.length];

							for (int i = 0; i < ctrconVersionVOs.length; ++i) {
								CtryContractVersionVO childVersionVO = (CtryContractVersionVO) ctrconVersionVOs[i];
								GuaCtryContractInfoVO childVO = new GuaCtryContractInfoVO();
								BeanUtils.copyProperties(childVersionVO, childVO);
								ctrconChildren[i] = childVO;
							}

							resultVO.setChildren(GuaCtryContractInfoVO.class, ctrconChildren);
						}
					}

					return new AggGuaContractVO[]{resultVO};
				}
			} catch (BusinessException var17) {
				ExceptionUtils.wrapException(var17);
			}
		}

		return (AggGuaContractVO[]) resultVOs;
	}

	protected List<PrecisionField> getHeadPrecisionField() {
		List<PrecisionField> list = new ArrayList();
		list.add(PrecisionField.buildHeadPrecisionField("guaamount", "gualcamount", "olcrate", "groamount", "glcrate",
				"gloamount", "gllcrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("pridebtamount", "debtamount", "olcdebtrate", "debtgroamount",
				"grodebtrate", "debtgloamount", "glodebtrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("usedamount", "orgusedamount", "olcrate", "grousedamount",
				"glcrate", "glousedamount", "gllcrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("avaamount", "orgavaamount", "olcrate", "groavaamount",
				"glcrate", "gloavaamount", "gllcrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("warocamount", "warlcamount", "olcrate", "wargroamount",
				"glcrate", "wargloamount", "gllcrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("pleamount", "plelcamount", "olcrate", "gropleamount",
				"glcrate", "glopleamount", "gllcrate", "guastartdate", "pk_currtype"));
		list.add(PrecisionField.buildHeadPrecisionField("moramount", "morlcamount", "olcrate", "gromoramount",
				"glcrate", "glomoramount", "gllcrate", "guastartdate", "pk_currtype"));
		return list;
	}

	protected Map<String, List<PrecisionField>> getBodyPrecisionField() {
		Map<String, List<PrecisionField>> map = new HashMap();
		List<PrecisionField> list1 = new ArrayList();
		list1.add(PrecisionField.buildBodyPrecisionField("waramount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		List<PrecisionField> list2 = new ArrayList();
		list2.add(PrecisionField.buildBodyPrecisionField("usingamount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		list2.add(PrecisionField.buildBodyPrecisionField("totalpledge", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		list2.add(PrecisionField.buildBodyPrecisionField("usinglcamount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		List<PrecisionField> list3 = new ArrayList();
		list3.add(PrecisionField.buildBodyPrecisionField("usingamount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		list3.add(PrecisionField.buildBodyPrecisionField("totalpledge", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		list3.add(PrecisionField.buildBodyPrecisionField("usinglcamount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		List<PrecisionField> list4 = new ArrayList();
		list4.add(PrecisionField.buildBodyPrecisionField("guaamount", (String) null, (String) null, (String) null,
				(String) null, (String) null, (String) null, "pk_currtype"));
		List<PrecisionField> list5 = new ArrayList();
		list5.add(PrecisionField.buildBodyPrecisionField("guaamount", "gualcamount", "olcrate", "groamount", "glcrate",
				"gloamount", "gllcrate", "pk_currtype"));
		map.put("warrantyinfo", list1);
		map.put("guarantyinfo", list2);
		map.put("pledgeinfo", list3);
		map.put("contractinfo", list4);
		map.put("detailinfo", list5);
		return map;
	}

	protected ExtBillCard buildFontResult(CardOperatorParam operaParam, AggGuaContractVO[] resultVOs) {
		ExtBillCard billCard = super.buildFontResult(operaParam, resultVOs);
		ExtraTranslator addExtraTransField = new ExtraTranslator();
		addExtraTransField.addExtraTransField("fincreditor", "name", BankdocVO.class);
		addExtraTransField.addExtraTransField("finguarantor", "name", BankdocVO.class);
		addExtraTransField.addExtraTransField("warrantorfin", "name", BankdocVO.class);
		addExtraTransField.translate(billCard);
		return billCard;
	}
}