package nccloud.zjcmp_cd.cd.tamx_registervo.action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.springframework.beans.BeanUtils;

import nc.bs.dao.BaseDAO;
import nc.bs.logging.Logger;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.bond.serviceproxy.TMCFMServiceProxy;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nc.vo.zjcmp_cd.onlineregon.AggTam_registerVO;
import nc.vo.zjcmp_cd.onlineregon.AggTamx_registerVersionVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersionVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersion_bVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_register_bVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.billcard.BillCard;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.bean.PageQueryInfo;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.util.CommonUtil;
/**
 * 
 * 查看版本列表
 * @author ZTH
 *
 */
public class GuaTamxQueryVersionCardAction extends Tamx_registerVOQueryCardAction {

	@Override
	public Object doAction(IRequest paramIRequest) {
		PageQueryInfo queryParam = this.getQueryParam(paramIRequest);
		try {
			
			
		    AggTam_registerVO aggvos= new AggTam_registerVO();
            // 查询数据版本
			Collection<AggTamx_registerVersionVO> versionbills = this.queryBills(queryParam);
			List<AggTamx_registerVersionVO> billsList = new ArrayList<>(versionbills);
			if (!billsList.isEmpty()) {
//				for (AggTamx_registerVersionVO vo : billsList) {
					if (billsList.get(0).getParentVO()!=null) {
						//版本VO转换最新VO
						Tamx_registerVersionVO  vesionheadvo=billsList.get(0).getParentVO();
						Tamx_registerVO headvo=new Tamx_registerVO();
						BeanUtils.copyProperties(vesionheadvo, headvo);
						
						Tamx_registerVersion_bVO[] vesionbodyvos=(Tamx_registerVersion_bVO[]) billsList.get(0).getChildrenVO();
						Tamx_register_bVO [] bodys=new Tamx_register_bVO[vesionbodyvos.length];
						for(int i=0 ;i<vesionbodyvos.length ;i++) {
							Tamx_registerVersion_bVO vesionbodyvo=vesionbodyvos[i];
							Tamx_register_bVO body=new  Tamx_register_bVO();
							BeanUtils.copyProperties(vesionbodyvo, body);
							bodys[i]=body;

						}
						
						aggvos.setChildren(Tamx_register_bVO.class, bodys);
						aggvos.setParentVO(headvo);
					}
//				}
					
								
			}
			return this.transBillCard(queryParam, aggvos);
		} catch (BusinessException ex) {
           // 处理异常信息
			Logger.error(ex);
			ExceptionUtils.wrapException(ex);
		}
		return null;
	}

	/**
	 * 获取查询参数
	 *
	 * @param paramIRequest
	 * @return
	 */
	private PageQueryInfo getQueryParam(IRequest paramIRequest) {
		String strRead = paramIRequest.read();
		PageQueryInfo queryParam = JsonFactory.create().fromJson(strRead, PageQueryInfo.class);
		return queryParam;
	}

	/**
	 * 查询业务数据
	 *
	 * @param queryParam
	 * @return
	 * @throws MetaDataException
	 */
	private Collection<AggTamx_registerVersionVO> queryBills(PageQueryInfo queryParam) throws MetaDataException {
		IMDPersistenceQueryService service = CommonUtil.getMDPersistenceQueryService();
         // 注意：业务提供查询方法（元数据查询默认查询到dr=1的数据了） IMDPersistenceQueryService
		
//		String cond = " pk_register = '"+originalPk+"' and isnull(dr,0) = 0 order by versionno desc";
//		Collection<?> result = TMCFMServiceProxy.getMDQueryService()
//				.queryBillOfVOByCond(AggTamx_registerVersionVO.class, cond, false);
//		if(result==null){
//			return null;
//		}
//		return result.toArray(new AggTamx_registerVersionVO[result.size()]);
		
		
		String wheresql = "pk_version" + "='" + queryParam.getPk() + "'   ";
		Collection<AggTamx_registerVersionVO> bills = service.queryBillOfVOByCond(AggTamx_registerVersionVO.class, wheresql, true,
				false);
		return bills;
	}

	/**
	 * VO 转换
	 *
	 * @param queryParam
	 * @param bill
	 * @return
	 */
	private BillCard transBillCard(PageQueryInfo queryParam, AggTam_registerVO aggvo) {
		if (aggvo == null) {
			return null;
		}
		BillCardOperator operator = new BillCardOperator(queryParam.getPagecode());
		return operator.toCard(aggvo);
	}

}
