package nccloud.zjcmp_cd.cd.tamx_registervo.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.logging.Logger;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.BusinessException;
import nc.vo.tmpub.util.StringUtil;
import nc.vo.zjcmp_cd.onlineregon.AggTamx_registerVersionVO;
import nccloud.dto.baseapp.querytree.dataformat.QueryTreeFormatVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.itf.zjcmp_cd.cd.ITamx_registervoMaintain;
import nccloud.web.common.gpmc.action.AbstractAction;
/**
 * 
 * 查看版本----左侧版本详情
 * @author ZTH
 *
 */
public class GuaTamxQueryVersionListAction extends AbstractAction<AggTamx_registerVersionVO> {

	 @Override
	 public Object doAction(IRequest request) {
		String read = request.read();
		IJson json = JsonFactory.create();
		QueryTreeFormatVO info = (QueryTreeFormatVO) json.fromJson(read, QueryTreeFormatVO.class);
		
		if (StringUtil.isNull(info.getPageInfo())) {
			ExceptionUtils.wrapBusinessException(
					"请求参数不能为空！");
		}

		String pageCode = info.getPageCode();
		if (StringUtil.isNull(pageCode)) {
			ExceptionUtils.wrapBusinessException("页面编码不能为空！");
		}
		
		
		try {
			String originalPk = info.getDef1();
			AggTamx_registerVersionVO[] vos = ((ITamx_registervoMaintain) ServiceLocator
					.find(ITamx_registervoMaintain.class)).queryVersionsByOrigPk(originalPk);
			if (vos != null && vos.length >= 1) {
				Map<String, Object> tmGrid = this.buildQryResult(vos);
				return tmGrid;
			} else {
				throw new BusinessException(
						"无历史版本");
			}
		} catch (BusinessException var9) {
			Logger.error(var9.getMessage(), var9);
			ExceptionUtils.wrapException(var9);
			return null;
		}
		
		
	}
	
	
		private Map<String, Object> buildQryResult(AggTamx_registerVersionVO[] vos) throws BusinessException {
			Map<String, Object> result = new HashMap();
			Map<String, Object> data = new HashMap();
			List<Map<String, Object>> rows = new ArrayList();
			AggTamx_registerVersionVO[] var5 = vos;
			int var6 = vos.length;

			for (int var7 = 0; var7 < var6; ++var7) {
				AggTamx_registerVersionVO vo = var5[var7];
				Map<String, Object> row = new HashMap();
				row.put("isleaf", true);
				row.put("refcode", vo.getParentVO().getBillno());
				row.put("refname", "版本"
						+ vo.getParentVO().getVersionno());
				row.put("refpk", vo.getParentVO().getPk_version());
				rows.add(row);
			}

			data.put("rows", rows);
			result.put("data", data);
			result.put("error", (Object) null);
			result.put("success", true);
			return result;
		}


}
