package nccloud.zjcmp_cd.cd.tamx_registervo.action;

import java.util.Collection;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IVOPersistence;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.pf.pub.util.SQLUtil;
import nc.vo.pub.BusinessException;
import nc.vo.zjcmp_cd.onlineregon.AggTam_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVO;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.bean.BillOperatorParam;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.util.CommonUtil;
/**
 * 
 * 注销按钮
 * 
 * @author PCY
 *
 */
public class Tamx_registerVOLogOutAction implements ICommonAction{
	
	IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);

	@Override
	public Object doAction(IRequest paramIRequest) {
		// TODO Auto-generated method stub
		BillOperatorParam queryParam = this.getQueryParam(paramIRequest);
		try {
			AggTam_registerVO[] bills = this.queryBills(queryParam);
			for(AggTam_registerVO bill:bills) {
				Tamx_registerVO head = bill.getParentVO();
				head.setVdef4("Y");
				try {
					IVOPersistence.updateVO(head);
				} catch (BusinessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (MetaDataException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	
	/**
	   * 获取查询参数
	   *
	   * @param paramIRequest
	   * @return
	   */
	  private BillOperatorParam getQueryParam(IRequest paramIRequest) {
	    String strRead = paramIRequest.read();
	    BillOperatorParam queryParam =
	        JsonFactory.create().fromJson(strRead, BillOperatorParam.class);
	    return queryParam;
	  }
	  
	  
	  /**
	   * 查询业务数据
	   *
	   * @param queryParam
	   * @return
	   * @throws MetaDataException
	   */
	  private AggTam_registerVO[] queryBills(BillOperatorParam queryParam)
	      throws MetaDataException {
	    // 1、根据参数查询结果
	    IMDPersistenceQueryService service = CommonUtil.getMDPersistenceQueryService();
	    String wheresql = SQLUtil.buildSqlForIn(
	        "pk_register", queryParam.getPks());

	    Collection<AggTam_registerVO> bills =
	        service.queryBillOfVOByCond(AggTam_registerVO.class, wheresql, true,
	            false);
	    if ((bills == null) || (bills.size() == 0)) {
	      return null;
	    }
	    return bills.toArray(new AggTam_registerVO[0]);
	  }
}
