
package nccloud.zjcmp_cd.cd.tamx_registervo.action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.logging.Logger;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.zjcmp_cd.onlineregon.AggTam_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_register_bVO;

import nc.vo.pub.BusinessException;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.billcard.BillCard;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.bean.PageQueryInfo;
import nccloud.zjcmp_cd.cd.tamx_registervo.cd.util.CommonUtil;

/**
 * 卡片查询（查询方案）操作
 * 
 * @version @since v3.5.6-1903
 */
public class Tamx_registerVOQueryCardAction implements ICommonAction {

	@Override
	public Object doAction(IRequest paramIRequest) {
		PageQueryInfo queryParam = this.getQueryParam(paramIRequest);
		try {
            // 查询数据
			Collection<AggTam_registerVO> bills = this.queryBills(queryParam);

			List<AggTam_registerVO> billsList = new ArrayList<>(bills);
			if (!billsList.isEmpty()) {
				for (AggTam_registerVO vo : billsList) {
					if (vo.getChildren(Tamx_register_bVO.class) == null) {
						String con = "pk_register='" + vo.getParentVO().getPk_register() + "'";
						Collection<Tamx_register_bVO> result = new BaseDAO().retrieveByClause(Tamx_register_bVO.class,
								con);
						List<Tamx_register_bVO> childs = new ArrayList<>(result);
						if (!childs.isEmpty()) {
							Tamx_register_bVO[] childArray = new Tamx_register_bVO[childs.size()];
							childs.toArray(childArray);
							vo.setChildren(Tamx_register_bVO.class, childArray);
						}
					}
				}
			}
			return this.transBillCard(queryParam, bills);
		} catch (BusinessException ex) {
            // 处理异常信息
			Logger.error(ex);
			ExceptionUtils.wrapException(ex);
		}
		return null;
	}

	/**
	 * 获取查询参数
	 *
	 * @param paramIRequest
	 * @return
	 */
	private PageQueryInfo getQueryParam(IRequest paramIRequest) {
		String strRead = paramIRequest.read();
		PageQueryInfo queryParam = JsonFactory.create().fromJson(strRead, PageQueryInfo.class);
		return queryParam;
	}

	/**
	 * 查询业务数据
	 *
	 * @param queryParam
	 * @return
	 * @throws MetaDataException
	 */
	private Collection<AggTam_registerVO> queryBills(PageQueryInfo queryParam) throws MetaDataException {
		IMDPersistenceQueryService service = CommonUtil.getMDPersistenceQueryService();
        // 注意：业务提供查询方法（元数据查询默认查询到dr=1的数据了）
		String wheresql = "pk_register" + "='" + queryParam.getPk() + "'";
		Collection<AggTam_registerVO> bills = service.queryBillOfVOByCond(AggTam_registerVO.class, wheresql, true,
				false);
		return bills;
	}

	/**
	 * VO 转换
	 *
	 * @param queryParam
	 * @param bill
	 * @return
	 */
	private BillCard transBillCard(PageQueryInfo queryParam, Collection<AggTam_registerVO> bills) {
		if (bills == null) {
			return null;
		}
		AggTam_registerVO bill = bills.toArray(new AggTam_registerVO[0])[0];
		BillCardOperator operator = new BillCardOperator(queryParam.getPagecode());
		return operator.toCard(bill);
	}
}
