package nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.BeanUtils;

import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.arap.uforeport.SqlBuffer;
import nc.vo.pub.BusinessException;
import nc.vo.zjcmp_cd.onlineregon.AggTam_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersionVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersion_bVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_register_bVO;
/*
 * 
 * 修改/变更最新版本的信息
 * 
 */
public class AceTamx_VersionUpdate implements IRule<AggTam_registerVO>{
	@Override
	public void process(AggTam_registerVO[] retvos) {
         IVOPersistence ivopersen =NCLocator.getInstance().lookup(IVOPersistence.class);
		 IUAPQueryBS iuap=NCLocator.getInstance().lookup(IUAPQueryBS.class);
		
		/**
		 * 
		 * 修改得情况
		 * 删除最新版本后在新增
		 * 
		 * 变更得情况
		 * 新增一条最新版本的数据
		 * 
		 */
		
		 Boolean flg=Boolean.FALSE;//变更标识  true:是	
		 int leng=retvos.length;
		 String[] pk_registers=new String[leng];
         List<Tamx_registerVersionVO> lisversionheadvos=new ArrayList<Tamx_registerVersionVO>();
         List<Tamx_registerVersion_bVO> lisversionbodys=new ArrayList<Tamx_registerVersion_bVO>();
         for(AggTam_registerVO aggvo:retvos) {
      	   Tamx_registerVO headvo= aggvo.getParentVO();
      	   Tamx_registerVersionVO versionheadvo=new Tamx_registerVersionVO();
      	   versionheadvo.setVersionno(headvo.getVdef2());//版本
      	   if(leng==retvos.length) {
      		    String vdef10=headvo.getVdef10();
				//2=变更完成就是变更操作
				if(null!=vdef10&&"2".equals(vdef10)) {
					flg=Boolean.TRUE;
				}
      		   
      	   }
      	   
      	   
      	   BeanUtils.copyProperties( headvo,versionheadvo);
      	   lisversionheadvos.add(versionheadvo);
      	   pk_registers[leng-1]=aggvo.getPrimaryKey();
      	   leng--;
      	   Tamx_register_bVO[] bodyvos=(Tamx_register_bVO[]) aggvo.getChildrenVO();
      	   for(Tamx_register_bVO body:bodyvos) {
      		   Tamx_registerVersion_bVO versionbodyvos=new Tamx_registerVersion_bVO();
      		   BeanUtils.copyProperties(body,versionbodyvos);
      		   lisversionbodys.add(versionbodyvos);
      		   
      	   }
      	     	   
         }
         
         
         //删除最新版本数据
         SqlBuffer sqlb=new SqlBuffer();
         sqlb.append(" pk_version in (");
         sqlb.append(" select pk_version from  v_tamx_registervesion where ");
         sqlb.append("pk_register",pk_registers);
         sqlb.append(" )"); 
         
         try {
        	 //true 是变更不进行删除原版数据的操作
        	 if(!flg) {
            	 //先删除子表在主表视图是主表为基准的
                 ivopersen.deleteByClause(Tamx_registerVersion_bVO.class, sqlb.toString());
                 ivopersen.deleteByClause(Tamx_registerVersionVO.class, sqlb.toString()); 
        	 }
             //新增最新的版本数据
        	 String[] pks=ivopersen.insertVOList(lisversionheadvos);
        	 for(Tamx_registerVersion_bVO versionbody:lisversionbodys) {
        		 versionbody.setPk_version(pks[0]); 
        	 }
			ivopersen.insertVOList(lisversionbodys);
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
