
package nccloud.impl.pub.ace;

import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOApproveBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVODeleteBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOInsertBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOSendApproveBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOUnApproveBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOUnSendApproveBP;
import nccloud.bs.zjcmp_cd.cd.aggbusi.ace.bp.AceTamx_registerVOUpdateBP;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.BeanUtils;

import com.ufida.zior.util.UUID;

import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.bill.BillLazyQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillTransferTool;
import nc.itf.uap.IVOPersistence;
import nc.ui.querytemplate.querytree.IQueryScheme;
import nc.vo.zjcmp_cd.onlineregon.AggTam_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersionVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_registerVersion_bVO;
import nc.vo.zjcmp_cd.onlineregon.Tamx_register_bVO;
import nc.vo.bd.util.StringUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public abstract class AceAggbusiTamx_registerVOPubServiceImpl {
	
        // 新增
        public AggTam_registerVO[] pubinsertBills(AggTam_registerVO[] clientFullVOs,
                        AggTam_registerVO[] originBills) throws BusinessException {
                try {
                        synchronized (clientFullVOs) {
                                // 数据库中数据和前台传递过来的差异VO合并后的结果
                                BillTransferTool<AggTam_registerVO> transferTool = new BillTransferTool<AggTam_registerVO>(
                                                clientFullVOs);
                                // 调用BP
                                AceTamx_registerVOInsertBP action = new AceTamx_registerVOInsertBP();
                                AggTam_registerVO[] retvos = action.insert(clientFullVOs);
                                // 构造返回数据
        //                      return transferTool.getBillForToClient(retvos);
                                
                             
                                
                                
                                return retvos;
                        }
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        // 删除
        public void pubdeleteBills(AggTam_registerVO[] clientFullVOs,
                        AggTam_registerVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                    BillTransferTool<AggTam_registerVO> transferTool =
                        new BillTransferTool<AggTam_registerVO>(clientFullVOs);
                        // 调用BP
                        new AceTamx_registerVODeleteBP().delete(clientFullVOs);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
        }

        // 修改
        public AggTam_registerVO[] pubupdateBills(AggTam_registerVO[] clientFullVOs,
                        AggTam_registerVO[] originBills) throws BusinessException {
                try {
                        // 加锁 + 检查ts
                        BillTransferTool<AggTam_registerVO> transferTool = new BillTransferTool<AggTam_registerVO>(
                                        clientFullVOs);
                        AceTamx_registerVOUpdateBP bp = new AceTamx_registerVOUpdateBP();
                        AggTam_registerVO[] retvos = bp.update(clientFullVOs, originBills);
                        
                        

                        // 构造返回数据
                        return transferTool.getBillForToClient(retvos);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return null;
        }

        public AggTam_registerVO[] pubquerybills(IQueryScheme queryScheme)
                        throws BusinessException {
                AggTam_registerVO[] bills = null;
                try {
                        this.preQuery(queryScheme);
                        BillLazyQuery<AggTam_registerVO> query = new BillLazyQuery<AggTam_registerVO>(
                                        AggTam_registerVO.class);
                        bills = query.query(queryScheme, null);
                } catch (Exception e) {
                        ExceptionUtils.marsh(e);
                }
                return bills;
        }

        /**
         * 由子类实现，查询之前对queryScheme进行加工，加入自己的逻辑
         * 
         * @param queryScheme
         */
        protected void preQuery(IQueryScheme queryScheme) {
                // 查询之前对queryScheme进行加工，加入自己的逻辑
        }

        // 提交
        public AggTam_registerVO[] pubsendapprovebills(
                        AggTam_registerVO[] clientFullVOs, AggTam_registerVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
        BillTransferTool<AggTam_registerVO> transferTool =
                new BillTransferTool<AggTam_registerVO>(clientFullVOs);
                AceTamx_registerVOSendApproveBP bp = new AceTamx_registerVOSendApproveBP();
                AggTam_registerVO[] retvos = bp.sendApprove(clientFullVOs, originBills);
                return retvos;
        }

        // 收回
        public AggTam_registerVO[] pubunsendapprovebills(
                        AggTam_registerVO[] clientFullVOs, AggTam_registerVO[] originBills)
                        throws BusinessException {
                // 加锁 + 检查ts
                BillTransferTool<AggTam_registerVO> transferTool =
                        new BillTransferTool<AggTam_registerVO>(clientFullVOs);
                AceTamx_registerVOUnSendApproveBP bp = new AceTamx_registerVOUnSendApproveBP();
                AggTam_registerVO[] retvos = bp.unSend(clientFullVOs, originBills);
                return retvos;
        };

        // 审批
        public AggTam_registerVO[] pubapprovebills(AggTam_registerVO[] clientFullVOs,
                        AggTam_registerVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<AggTam_registerVO> transferTool =
                        new BillTransferTool<AggTam_registerVO>(clientFullVOs);
                AceTamx_registerVOApproveBP bp = new AceTamx_registerVOApproveBP();
                AggTam_registerVO[] retvos = bp.approve(clientFullVOs, originBills);
                return retvos;
        }

        // 弃审

        public AggTam_registerVO[] pubunapprovebills(AggTam_registerVO[] clientFullVOs,
                        AggTam_registerVO[] originBills) throws BusinessException {
                for (int i = 0; clientFullVOs != null && i < clientFullVOs.length; i++) {
                        clientFullVOs[i].getParentVO().setStatus(VOStatus.UPDATED);
                }
                // 加锁 + 检查ts
                BillTransferTool<AggTam_registerVO> transferTool =
                        new BillTransferTool<AggTam_registerVO>(clientFullVOs);
                AceTamx_registerVOUnApproveBP bp = new AceTamx_registerVOUnApproveBP();
                AggTam_registerVO[] retvos = bp.unApprove(clientFullVOs, originBills);
                return retvos;
        }

}